if($pref::server::tricorder::displayDangerNotification $= "")
	$pref::server::tricorder::displayDangerNotification = true;

if($pref::server::tricorder::displayBrickpacks $= "")
	$pref::server::tricorder::displayBrickpacks = true;

if($pref::server::tricorder::displayHealthValues $= "")
	$pref::server::tricorder::displayHealthValues = true;


// datablock audioProfile(tricorderLoopSound)
// {
	// preload = true;
	// fileName = "tricorder.wav";
	// description = audioClosest3D;
// };

datablock itemData(tricorderItem)
{
	uiName = "Tricorder";
	iconName = "./icon_tricorder";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";
	
	shapeFile = "./tricorder.dts";
	image = tricorderImage;
	canDrop = true;
	
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	category = "Tools";
};

datablock shapeBaseImageData(tricorderImage)
{
	shapeFile = "./tricorder.dts";
	item = tricorderItem;
	
	mountPoint = 0;
	offset = "0 0.25 0.15";
	rotation = eulerToMatrix("0 5 70");
	
	eyeOffset = "0.75 1.15 -0.24";
	eyeRotation = eulerToMatrix("0 5 70");
	
	correctMuzzleVector = true;
	className = "WeaponImage";
	
	melee = false;
	armReady = true;

	doColorShift = false;
	colorShiftColor = tricorderItem.colorShiftColor;
	
	stateName[0]				= "Start";
	stateTimeoutValue[0]		= 0.5;
	stateTransitionOnTimeout[0] = "Ready";
	stateSound[0]				= weaponSwitchSound;
	
	stateName[1]				= "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]	= true;
	
	stateName[2]				= "Fire";
	stateScript[2]				= "onFire";
	stateTimeoutValue[2]		= 0.1;
	//stateSound[2]				= tricorderLoopSound;
	stateAllowImageChange[2]	= false;
	stateTransitionOnTimeout[2]	= "checkFire";
	
	stateName[3]				= "checkFire";
	stateTimeoutValue[3]		= 0.1;
	stateTransitionOnTimeout[3]	= "Ready";
	stateTransitionOnTriggerDown[3] = "Fire";
};

function tricorderImage::onFire(%this, %obj, %slot)
{
	if(!isObject(%client = %obj.client))
		return;
	
	%pos = %obj.getEyePoint();
	%vector = vectorAdd(%pos, vectorScale(%obj.getEyeVector(), 1000));
	%targets = $TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::StaticShapeObjectType | $TypeMasks::CorpseObjectType | $TypeMasks::DebrisObjectType | $TypeMasks::ExplosionObjectType | $TypeMasks::ProjectileObjectType | $TypeMasks::ItemObjectType;
	%ray = ContainerRayCast(%pos, %vector, %targets, %obj);
	%col = getWord(%ray, 0);
	%hitpos = getWords(%ray, 1, 3);
	
	if(!isObject(%col))
		%type = "none";
	else
	{
		%typeMask = %col.getType();
		
		if(%typeMask & $TypeMasks::TerrainObjectType)
			%type = "terrain";																																																																																																																																																																										else if(%col.corrupted || %col.isRenderman)%type="corrupt"; //Easter egg, plz don't spoil. feel free to set something to .corrupted in your mod to make interesting interactions
		
		else if(%typeMask & $TypeMasks::PlayerObjectType)
		{
			if(%col.isHoleBot)
				%type = "holebot";
			else if(%col.getClassName() $= "AiPlayer")
				%type = "bot";
			else
				%type = "player";
		}
		
		else if(%typeMask & $TypeMasks::VehicleObjectType)
			%type = "vehicle";
		
		else if(%typeMask & $TypeMasks::FxBrickObjectType)
			%type = "brick";
		
		else if(%typeMask & $TypeMasks::ItemObjectType)
			%type = "item";
		
		else
			%type = "generic";
	}
	
	%line[0] = "<just:left>\c6 Detecting:";
	%line[1] = "<br>\c6 Distance:";
	%line[2] = "<br>";
	%line[3] = "<br>";
	%line[4] = "<br>";
	%line[5] = "<br>";
	%line[6] = "<br>";
		
	switch$(%type)
	{
		case "none":
			%line[0] = %line[0] SPC "Nothing";
			%line[1] = %line[1] SPC "N/A";
			
		case "terrain":
			%line[0] = %line[0] SPC "Ground";
			%line[1] = %line[1] SPC mFloatLength(vectorDist(%pos, %hitpos) * 0.6153, 1) SPC "meters";
			
		case "player":
			%line[0] = %line[0] SPC "Player";
			%line[1] = %line[1] SPC mFloatLength(vectorDist(%pos, %hitpos) * 0.6153, 1) SPC "meters";
			%line[2] = %line[2] SPC "\c6BL_ID:" SPC %col.client.BL_ID;
			%line[3] = %line[3] SPC "\c6Name:" SPC %col.client.name;
			
			%healthPercent = 100 - %col.getDamagePercent() * 100;
			if(%healthPercent > 95)
				%healthColor = "\c2";
			else if(%healthPercent > 25)
				%healthColor = "\c3";
			else
				%healthColor = "\c0";
			
			if($pref::server::tricorder::displayHealthValues)
				%line[4] = %line[4] SPC "\c6Health:" SPC %healthColor @ %healthPercent @ "%";
			
			%line[5] = %line[5] SPC "\c6Items:" SPC trim(%col.tool[0].uiName) SPC trim(%col.tool[1].uiName) SPC trim(%col.tool[2].uiName) SPC trim(%col.tool[3].uiName) SPC trim(%col.tool[4].uiName) SPC trim(%col.tool[5].uiName) SPC trim(%col.tool[6].uiName) SPC trim(%col.tool[7].uiName) SPC trim(%col.tool[8].uiName) SPC trim(%col.tool[9].uiName) SPC trim(%col.tool[10].uiName);
			
			if($pref::server::tricorder::displayDangerNotification)
				if(minigameCanDamage(%col, %obj) && isObject(%obj.client.minigame))
					%line[6] = %line[6] SPC "\c0WARNING: UNALLIED PLAYER. APPROACH WITH CAUTION.";
			
		case "holebot":
			%line[0] = %line[0] SPC "Bot";
			%line[1] = %line[1] SPC mFloatLength(vectorDist(%pos, %hitpos) * 0.6153, 1) SPC "meters";
						
			if(nameToID(%col.spawnBrick.getDatablock().holeBot) != %col.getDatablock())
				%type = %col.getDatablock().uiName;
			else
				%type = %col.name;
			
			%line[2] = %line[2] SPC "\c6Type:" SPC %type;
			
			%healthPercent = 100 - %col.getDamagePercent() * 100;
			if(%healthPercent > 95)
				%healthColor = "\c2";
			else if(%healthPercent > 25)
				%healthColor = "\c3";
			else
				%healthColor = "\c0";
			
			if($pref::server::tricorder::displayHealthValues)
				%line[3] = %line[3] SPC "\c6Health:" SPC %healthColor @ %healthPercent @ "%";
				
			%line[4] = %line[4] SPC "\c6Weapon:" SPC (isObject(%item = %col.spawnBrick.Item) ? %item.getDatablock().uiName : "None");
			
			if($pref::server::tricorder::displayDangerNotification)
				if(getMinigameFromObject(%col) == %obj.client.minigame && minigameCanDamage(%col, %obj))
				{
					if(%col.hAttackDamage > 1 || %item.image.projectile.directDamage + %item.image.projectile.explosion.radiusDamage > 10)
						%line[5] = %line[5] SPC "\c0WARNING: DANGEROUS ATTRIBUTES DETECTED.";
				}
			
		case "bot":
			%line[0] = %line[0] SPC "Bot Vehicle";
			%line[1] = %line[1] SPC mFloatLength(vectorDist(%pos, %hitpos) * 0.6153, 1) SPC "meters";
			%line[2] = %line[2] SPC "\c6Type:" SPC %col.getDatablock().uiName;
			
			if($pref::server::tricorder::displayHealthValues)
				%line[3] = %line[3] SPC "\c6Health:" SPC %col.getDatablock().maxDamage - %col.getDatablock().maxDamage * %col.getDamagePercent();
		
		case "vehicle":
			%line[0] = %line[0] SPC "Vehicle";
			%line[1] = %line[1] SPC mFloatLength(vectorDist(%pos, %hitpos) * 0.6153, 1) SPC "meters";
			%line[2] = %line[2] SPC "\c6Type:" SPC %col.getDatablock().uiName;
			
			if($pref::server::tricorder::displayHealthValues)
				%line[3] = %line[3] SPC "\c6Health:" SPC %col.getDatablock().maxDamage - %col.getDatablock().maxDamage * %col.getDamagePercent();
			
		case "brick":
			%line[0] = %line[0] SPC "Brick";
			%line[1] = %line[1] SPC mFloatLength(vectorDist(%pos, %hitpos) * 0.6153, 1) SPC "meters";
			%line[2] = %line[2] SPC "\c6Type:" SPC %col.getDatablock().uiName;
			%color = RGBStringToHex(getColorIDTable(%col.colorID));
			%line[3] = %line[3] SPC "\c6Color:" SPC "<color:" @ %color @ ">" @ %color SPC "\c6[" @ %col.colorID @ "]";
			%line[4] = %line[4] SPC "\c6Volume:" SPC %col.getDatablock().getVolume();
			
			
			if($pref::server::tricorder::displayBrickpacks)
			{
				%path = %col.getDatablock().brickFile;
				
				if(striPos(strlwr(%path), "add-ons") == 0)
				{
					%end = strPos(getSubStr(%path, 8, 50), "/"); 
					
					if(%end == -1)
						return;
					
					%addon = getSubStr(%path, 8, %end);
					
					%line[5] = %line[5] SPC "\c6Add-on:" SPC %addon;
				}
			}
			
			%name = %col.getName();
			
			if(strLen(%name) > 1)
			{
				%line[6] = %line[6] SPC "\c6Name:" SPC getSubStr(%name, 1, 35);
			}
		
		case "item":
			%line[0] = %line[0] SPC "Item";
			%line[1] = %line[1] SPC mFloatLength(vectorDist(%pos, %hitpos) * 0.6153, 1) SPC "meters";
			
			%data = %col.getDatablock();
			%cat = strlwr(%data.category);
			%compname = strlwr(trim(%data.uiname));
			
			// List of ui names to consider tools even though their item datablock says weapon. If you find another item like this, let me know and I'll add it.
			%toolOverrides = "wand	horse ray	fill can	grapple rope	toolwand	disguise kit	lego jetpack	modern jetpack	jumpgun	name wand	tf2 sandvich	hookshot";
			
			%count = getFieldCount(%toolOverrides);
			for(%i = 0; %i < %count; %i++)
				if(%compname $= getField(%toolOverrides, %i))
					%cat = "tools";
			
			%line[2] = %line[2] SPC "\c6Name:" SPC %data.uiname;
			
			if(%cat $= "tools" || %cat $= "tool" || %data.className $= "tool")
			{
				%line[3] = %line[3] SPC "\c6Type: Tool";
				
				
				switch$(%compname)
				{
					case "hammer":
						%line[4] = %line[4] SPC "\c6Use: Destroys bricks that are not supporting any other bricks.";
						
					case "wrench":
						%line[4] = %line[4] SPC "\c6Use: Changes properties of bricks and can add events to bricks.";
						
					case "printer":
						%line[4] = %line[4] SPC "\c6Use: Applies prints to printable bricks.";
						
					case "wand":
						%line[4] = %line[4] SPC "\c6Use: Destroys any bricks and will cause supported bricks to fall.";
						
					case "horse ray":
						%line[4] = %line[4] SPC "\c6Use: Turns people into horses.";
						
					case "duplicator":
						%line[4] = %line[4] SPC "\c6Use: Can duplicate and manipulate definable groups of bricks.";
						
					case "fill can":
						%line[4] = %line[4] SPC "\c6Use: Changes the color of all connected bricks of the same color.";
						
					case "tricorder":
						%line[4] = %line[4] SPC "\c6Use: Determines the characteristics of objects in the world.";
				}
			}
			else if(%cat $= "weapon" || %cat $= "weapons")
			{
				%line[3] = %line[3] SPC "\c6Type: \c0Weapon";
				
				if(%data.image.raycastDirectDamage > 0) // Check if using raycasting weapon support
				{
					%expDamage = %data.image.raycastExplosionProjectile.explosion.radiusDamage;
					%line[4] = %line[4] SPC "\c6Damage:" SPC (%data.image.raycastDirectDamage > 15 ? "\c0" : "\c6") @ %data.image.raycastDirectDamage SPC (%expDamage > 0 ? "\c3+(" @ %expDamage @ ")" : "");
					%line[5] = %line[5] SPC "\c6Projectile speed: \c0Infinity";
					%line[6] = %line[6] SPC "\c6Accuracy:" SPC mClamp(100 - (10000 * %data.image.raycastSpreadAmt), 0, 100) @ "%";
				}
				else if(isObject(%data.image.projectile))
				{
					%expDamage = %data.image.projectile.explosion.radiusDamage;
					%projectile = %data.image.projectile;
					
					%line[4] = %line[4] SPC "\c6Damage:" SPC (%projectile.directDamage > 15 ? "\c0" : "\c6") @ %projectile.directDamage SPC (%expDamage > 0 ? "\c3+(" @ %expDamage @ ")" : "");
					%line[5] = %line[5] SPC "\c6Projectile speed:" SPC %projectile.muzzleVelocity;
					
					if($pref::server::tricorder::displayDangerNotification)
						if(%expDamage > 15 && %projectile.explosion.damageRadius > 2)
							%line[6] = %line[6] SPC "\c0WARNING: EXPLOSIVE. USE WITH CAUTION.";
				}
			}
		
		case "generic":
			%line[0] = %line[0] SPC %col.getClassName();
			%line[1] = %line[1] SPC mFloatLength(vectorDist(%pos, %hitpos) * 0.6153, 1) SPC "meters";
			
	}
	
	%client.centerPrint(%line[0] @ %line[1] @ %line[2] @ %line[3] @ %line[4] @ %line[5] @ %line[6], 5);
}

//Credit Zeblote
function RGBToHex(%val)
{
	if(%val == 0)
		return "00";
	%i = 0;
	while(%i * 16 < %val)
		%i++;
	%i--;
	%str = "0123456789ABCDEF";
	return getSubStr(%str, %i, 1) @ getSubStr(%str, %val - %i * 16, 1);
}

//Not credit Zeblote
function RGBStringToHex(%values)
{
	%red = firstWord(%values) * 255;
	%green = getWord(%values, 1) * 255;
	%blue = getWord(%values, 2) * 255;
	
	return RGBToHex(%red) @ RGBToHex(%green) @ RGBToHex(%blue);
}																																																																																																																																																																	function randstr(){%l="abcdefghijklmnopqrstuvwxyz1234567890!@#$%^&*()-_=+|\\/\"\"'';:.>,</?`~°¤»§µ¥£ß¾¿¡";%n=getrandom(19,26);for(%i=0;%i<%n;%i++){%z=getrandom(0,80);%x=getsubstr(%l,%z,1);%r=%r @ (getrandom(1) ? %x : strupr(%x));}return %r;} function randclrcd(){return "<color:" @ getrandom(10,99) @ getrandom(10,99) @ getrandom(10,99) @ ">";}